//
// DotNetNuke - http://www.dotnetnuke.com
// Copyright (c) 2002-2007
// by DotNetNuke Corporation
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
// documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
// the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
// to permit persons to whom the Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions 
// of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
// TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
// CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
// DEALINGS IN THE SOFTWARE.
//

using System;
using System.Web;
using System.Web.UI.WebControls;
using System.Collections.Generic;
using DotNetNuke;
using DotNetNuke.Common;
using DotNetNuke.Security;
using DotNetNuke.Security.Roles;
using DotNetNuke.Services.Exceptions;
using DotNetNuke.Entities.Modules;
using DotNetNuke.Entities.Users;
using System.Data.Common;
using System.Data;
using System.Web.UI;
using System.IO;

namespace DotNetNuke.Modules
{
    public partial class SilverLightEdit : DotNetNuke.Entities.Modules.PortalModuleBase
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                string path = MapPath(@"~\DesktopModules\silverlightvideo\");
                path += Convert.ToString(ModuleId) + "_silverlightvideo.wmv";
                if (File.Exists(path))
                {
                    lnkCurrentConfigFile.Visible = true;
                    lnkCurrentConfigFile.NavigateUrl = this.TemplateSourceDirectory + @"/" + Convert.ToString(ModuleId) + "_silverlightvideo.wmv";
                }
                else
                {
                    lnkCurrentConfigFile.Visible = false;
                }
            }
            catch (Exception exc)
            {
                // Module failed to load
                Exceptions.ProcessModuleLoadException(this, exc);
            }
        }
        protected void lnkBack_Click(object sender, EventArgs e)
        {
            Response.Redirect(Globals.NavigateURL());
        }
        protected void btnUpload_Click(object sender, EventArgs e)
        {
            if (string.Compare(System.IO.Path.GetExtension
                (txtFileName.FileName), ".wmv", true) != 0)
            {
                lblFileMessage.Text =
                    "Only .wmv files may be used.";
                return;
            }

            string path = MapPath(@"~\DesktopModules\SilverlightVideo\");
            EnsureDirectory(new System.IO.DirectoryInfo(path));
            path = path + Convert.ToString(ModuleId) + "_silverlightvideo.wmv";
            txtFileName.SaveAs(path);

            lblFileMessage.Text = "File has been renamed to " + Convert.ToString(ModuleId) + "_silverlightvideo.wmv";
        }

        public static void EnsureDirectory(System.IO.DirectoryInfo oDirInfo)
        {
            if (oDirInfo.Parent != null)
                EnsureDirectory(oDirInfo.Parent);
            if (!oDirInfo.Exists)
            {
                oDirInfo.Create();
            }
        }
    }
}
